'download from : www.bargh20.com

$regfile = "m8def.dat"
$crystal = 16000000
$hwstack = 200
$swstack = 200
$framesize = 200  
'------------------------------------------------------------------

Config Pind.3 = Input , Pind.7 = Input , Pinc.0 = Output , _
Pinc.1 = Output , Pind.2 = Output , Pind.1 = Output , _
Pind.0 = Output , Pind.5 = Input , Pinc.2 = Output , _
Pinb.1 = Output , Pinb.2 = Output
Config Adc = Single , Prescaler = 4 , Reference = Internal
Config Spi = Hard , Interrupt = Off , Data Order = Msb , _
Master = Yes , Polarity = Low , Phase = 0 , Clockrate = 4 , Noss = 1
Config Watchdog = 256


'-------------------------------------------------------------------

Declare Sub Wrt_cmd(byval Cmd As Word)
Declare Sub Send_data(byval_data As Byte)

'-------------------------------------------------------------------

Dim W As Byte , X As Byte , Y As Word , Z As Byte
Dim I As Byte
Dim Adc_value As Word , Adc_value2 As Word , Adc_value3 As Byte
Dim Bit1 As Bit , Bit2 As Bit , Data_counter As Byte , Code(4) As Byte
Dim Command(2) As Byte

'-------------------------------------------------
Const _on = 1 : Const _off = 0                              'www.bargh20.com
'-------------------------------------------------------------------

Nirq Alias Pind.7
Nsel Alias Portb.2
Tx_en Alias Portc.0 : Rx_en Alias Portc.1
Send_led Alias Portd.1
Ptt_key Alias Pind.5

'---------------------------------------------------------------------

Spiinit
Set Portd.0
Rx_en = 1 : Tx_en = 0

'-------------------------------------------------------------------
Start Adc
Start Watchdog                                              'www.bargh20.com
'---------------------------------------------------------

Wrt_cmd &H80D7
Wrt_cmd &H8039
Wrt_cmd &HA680
Wrt_cmd &HC601
Wrt_cmd &H9403
Wrt_cmd &HC26F
Wrt_cmd &HC484
Wrt_cmd &H98F0
Wrt_cmd &HE000
Wrt_cmd &HC800
Wrt_cmd &HC000
Wrt_cmd &H8201
Do
  If Ptt_key = 0 And Bit1 = 0 Then
     Bit1 = 1 : Bit2 = 0 : Rx_en = 0 : Tx_en = 1
     Wrt_cmd &H8201 : Wrt_cmd &HCA81 : Send_led = _on
     Gosub Send_packet
  End If
Loop

'-------------------------------------------------------send send packet

Send_packet:
  While Ptt_key = 0

  '--------------------------------open tx

     Wrt_cmd &H0000
     Wrt_cmd &H8239
     Send_data &HAA
     Send_data &HAA
     Send_data &HAA
     Send_data &H2D
     Send_data &HD4

     '----------------------------send start data

     Send_data &H01
     Send_data &HF4

     '-------------------------------send data

     For Y = 1 To 510
      Reset Watchdog
      Adc_value = Getadc(2)
      Shift Adc_value , Right , 2
      Adc_value3 = Adc_value
      Send_data Adc_value3
    Next

  '-------------------------------------close tx

   Send_data &HAA
   Send_data &HAA
   Send_data &HAA
   Wrt_cmd &H8201
  Wend
 Return

 '------------------------------send data to majule

 Sub Send_data(byval_data As Byte)
   Bitwait Nirq , Reset
   Wrt_cmd &HB800 + _data
 End Sub

 '--------------------------------write commandto majule

 Sub Wrt_cmd(byval Cmd As Word)
  Reset Nsel
  Command(1) = High(cmd) : Command(2) = Low(cmd)
  Spiout Command(1) , 1
  W = Spimove(command(2))
  Set Nsel
 End Sub

 '----------------------------------------------------------------
End