'download from : www.bargh20.com

$regfile = "m8def.dat"
$crystal = 16000000
$hwstack = 200
$swstack = 200
$framesize = 200
'------------------------------------------------------------------

Config Pind.3 = Input , Pind.7 = Input , Pinc.0 = Output , _
Pinc.1 = Output , Pind.2 = Output , Pind.1 = Output , _
Pind.0 = Output , Pind.5 = Input , Pinc.2 = Output , _
Pinb.1 = Output , Pinb.2 = Output
Config Spi = Hard , Interrupt = Off , Data Order = Msb , _
Master = Yes , Polarity = Low , Phase = 0 , Clockrate = 4 , Noss = 1
Config Timer1 = Pwm , Pwm = 8 , Prescale = 1 , Compare A Pwm = Clear Down
Config Watchdog = 256

'--------------------------------------------------------------------

Declare Sub Wrt_cmd(byval Cmd As Word)
Declare Sub Send_data(byval_data As Byte)

'-------------------------------------------------------------------

Dim W As Byte , X As Byte , Y As Word , Z As Byte
Dim I As Byte
Dim Data_counter As Byte , Code(4) As Byte , Audio_enable As Bit
Dim Command(2) As Byte

'-------------------------------------------------
Const _on = 1 : Const _off = 0
'-------------------------------------------------------------------

Nirq Alias Pind.7
Nsel Alias Portb.2
Tx_en Alias Portc.0 : Rx_en Alias Portc.1
Receive_led Alias Portd.0
Ptt_key Alias Pind.5

'---------------------------------------------------------------------

Spiinit
Set Portd.0
Rx_en = 1 : Tx_en = 0

'-------------------------------------------------------------------
Start Adc
Start Watchdog
'---------------------------------------------------------

Wrt_cmd &H80D7
Wrt_cmd &H8239
Wrt_cmd &HA680
Wrt_cmd &HC601
Wrt_cmd &H9403
Wrt_cmd &HC26F
Wrt_cmd &HC484
Wrt_cmd &H98F0
Wrt_cmd &HE000
Wrt_cmd &HC800
Wrt_cmd &HC000
Wrt_cmd &H8201
Do
  Tx_en = 0 : Rx_en = 1
  Wrt_cmd &H82D9
  Wrt_cmd &HCA83
  Gosub Receive_data
Loop

'-------------------------------------------------------send data to majule
Sub Send_data(byval_data As Byte)
  Bitwait Nirq , Reset
  Wrt_cmd &HB800 + _data
End Sub

'----------------------------------------receive data from majule

Receive_data:
  Wrt_cmd &HCA83
  For Y = 1 To 512
    Bitwait Nirq , Reset
    Wrt_cmd &H0000
    Wrt_cmd &HB000
    If Y = 1 Then Code(1) = W
    If Y = 2 Then Code(2) = W
    If Code(1) = &H01 And Code(2) = &HF4 Then
       Audio_enable = 1 : Receive_led = _on
    End If
    If Y > 2 And Audio_enable = 1 Then Pwm1a = W
    Reset Watchdog
  Next
  Wrt_cmd &HCA81 : Audio_enable = 0
 Return
'------------------------------------------------------write command to majule
  Sub Wrt_cmd(byval Cmd As Word)
    Reset Nsel
    Command(1) = High(cmd) : Command(2) = Low(cmd)
    Spiout Command(1) , 1
    W = Spimove(command(2))
    Set Nsel
  End Sub
  End